-- Specjalizacja dla Glebogryzarka --
-- Autor: Rockstar94 --
-- Data: 21.10.2015 --



Glebogryzarka = {};

function Glebogryzarka.prerequisitesPresent(specializations)
return true;
end;

function Glebogryzarka:load(xmlFile)
    if self.isClient then
        self.glebogryzarka = Utils.loadSample(xmlFile, {}, "vehicle.glebogryzarkaSound", nil, self.baseDirectory);
		
		self.glebogryzarkaTurnedOnRotationNodes = Utils.loadRotationNodes(xmlFile, {}, "vehicle.turnedOnRotationNodes.turnedOnRotationNode", "glebogryzarka", self.components);

		self.glebogryzarkaParticleSystems = {};
		local i=0;
		while true do
			local baseName = string.format("vehicle.glebogryzarkaParticleSystems.glebogryzarkaParticleSystem(%d)", i);

			local particleSystem = {};
			particleSystem.ps = {};
			local ps = Utils.loadParticleSystem(xmlFile, particleSystem.ps, baseName, self.components, false, nil, self.baseDirectory)
			if ps == nil then
				break;
			end;
			table.insert(self.glebogryzarkaParticleSystems, particleSystem);
			i = i+1;
		end;
    end;
end;

function Glebogryzarka:delete()
    if self.isClient then
        Utils.deleteSample(self.glebogryzarka);
		
		for k, v in pairs(self.glebogryzarkaParticleSystems) do
			Utils.deleteParticleSystem(v.ps)
		end;
	end;
end;

function Glebogryzarka:keyEvent(unicode, sym, modifier, isDown)
 end;
 
function Glebogryzarka:update(dt)	
    if self:getIsActive() then
        if self:getIsTurnedOn() then
			if self.isClient and self:getIsActiveForSound() then
				Utils.playSample(self.glebogryzarka, 0, 0, nil);
			end;	
		else
			if self.isClient then
				Utils.stopSample(self.glebogryzarka);
			end;
		end;
	end;
	
	if self.isClient then
		Utils.updateRotationNodes(self, self.glebogryzarkaTurnedOnRotationNodes, dt, self:getIsActive() and self:getIsTurnedOn() );
	end;
	
    if self:getIsActive() then
        if self.isTurnedOn then	
			if self:isLowered(true) then
				for k,v in ipairs(self.glebogryzarkaParticleSystems) do
					Utils.setEmittingState(v.ps, true);
				end;
			end;
		end;
	end;
	
	if not self.isTurnedOn or not self:isLowered(false) then
		for k,v in ipairs(self.glebogryzarkaParticleSystems) do
			Utils.setEmittingState(v.ps, false);
		end;
	end;
end;

function Glebogryzarka:onDeactivateSounds()
    if self.isClient then
        Utils.stopSample(self.glebogryzarka, true);
    end;
end;

function Glebogryzarka:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Glebogryzarka:validateAttacherJoint(implement, jointDesc, dt)
return true;
end;

function Glebogryzarka:draw()
end;